package lab;

import lab.data.Commit;
import lab.repository.CommitRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.FileReader;
import java.text.SimpleDateFormat;
import java.util.Locale;

@Service
@ConditionalOnProperty(name = "job.enabled", havingValue = "ImportCommitJob")
public class ImportCommitJob implements CommandLineRunner {

    @Autowired
    private CommitRepository commitRepository;

    private String filename = "logdump";

    @Override
    public void run(String... strings) throws Exception {
        SimpleDateFormat dateFormat = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss Z", Locale.ENGLISH);
        try(BufferedReader reader = new BufferedReader(new FileReader(filename))){
            String line;
            while((line = reader.readLine()) != null){
                Commit commit = new Commit()
                        .setCommitHash(line)
                        .setAuthorName(reader.readLine())
                        .setAuthorEmail(reader.readLine())
                        .setAuthorDateRaw(reader.readLine())
                        .setCommitterName(reader.readLine())
                        .setCommitterEmail(reader.readLine())
                        .setCommitterDateRaw(reader.readLine())
                        .setSubject(reader.readLine());
                commit.setAuthorDate(dateFormat.parse(commit.getAuthorDateRaw()).getTime());
                commit.setCommitterDate(dateFormat.parse(commit.getCommitterDateRaw()).getTime());
                commitRepository.save(commit);
                reader.readLine();
            }
        }
    }
}
