package lab.data;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;

@Entity
public class MyAuthor {

    @Id
    private long myAuthorId;

    @CollectionTable(
            indexes = @Index(columnList = "authorName")
    )
    @ElementCollection
    private Set<String> authorName;

    @CollectionTable(
            indexes = @Index(columnList = "authorEmail")
    )
    @ElementCollection
    private Set<String> authorEmail;

    public MyAuthor(long myAuthorId, String authorName, String authorEmail) {
        this.myAuthorId = myAuthorId;
        this.authorName = new HashSet<>();
        this.authorEmail = new HashSet<>();
        this.authorName.add(authorName);
        this.authorEmail.add(authorEmail);
    }

    public MyAuthor() {
    }

    public long getMyAuthorId() {
        return myAuthorId;
    }

    public MyAuthor setMyAuthorId(long myAuthorId) {
        this.myAuthorId = myAuthorId;
        return this;
    }

    public Set<String> getAuthorName() {
        return authorName;
    }

    public MyAuthor setAuthorName(Set<String> authorName) {
        this.authorName = authorName;
        return this;
    }

    public Set<String> getAuthorEmail() {
        return authorEmail;
    }

    public MyAuthor setAuthorEmail(Set<String> authorEmail) {
        this.authorEmail = authorEmail;
        return this;
    }
}
