package lab.data;

import javax.persistence.*;

@Entity
@Table(
        indexes = {
                @Index(columnList = "messageId", unique = true),
                @Index(columnList = "sendTime"),
                @Index(columnList = "inReplyTo")
        }
)
public class Patch {

    @Id
    private long patchworkId;

    @Column(length = 255)
    private String messageId;

    @Column
    private long sendTime;

    @Column
    private String sendTimeRaw;

    @Column(columnDefinition = "TEXT")
    private String authorName;

    @Column(columnDefinition = "TEXT")
    private String authorEmail;

    @Column(columnDefinition = "TEXT")
    private String subject;

    @Column(length = 255)
    private String inReplyTo;

    @Column(columnDefinition = "TEXT")
    private String referenceList;

    @Column(columnDefinition = "LONGTEXT")
    private String mbox;

    public Patch(long patchworkId, String authorName, String authorEmail) {
        this.patchworkId = patchworkId;
        this.authorName = authorName;
        this.authorEmail = authorEmail;
    }

    public Patch(long patchworkId, long sendTime, String authorName, String authorEmail, String subject) {
        this.patchworkId = patchworkId;
        this.sendTime = sendTime;
        this.authorName = authorName;
        this.authorEmail = authorEmail;
        this.subject = subject;
    }

    public Patch() {
    }

    public long getPatchworkId() {
        return patchworkId;
    }

    public Patch setPatchworkId(long patchworkId) {
        this.patchworkId = patchworkId;
        return this;
    }

    public String getMessageId() {
        return messageId;
    }

    public Patch setMessageId(String messageId) {
        this.messageId = messageId;
        return this;
    }

    public long getSendTime() {
        return sendTime;
    }

    public Patch setSendTime(long sendTime) {
        this.sendTime = sendTime;
        return this;
    }

    public String getSendTimeRaw() {
        return sendTimeRaw;
    }

    public Patch setSendTimeRaw(String sendTimeRaw) {
        this.sendTimeRaw = sendTimeRaw;
        return this;
    }

    public String getAuthorName() {
        return authorName;
    }

    public Patch setAuthorName(String authorName) {
        this.authorName = authorName;
        return this;
    }

    public String getAuthorEmail() {
        return authorEmail;
    }

    public Patch setAuthorEmail(String authorEmail) {
        this.authorEmail = authorEmail;
        return this;
    }

    public String getSubject() {
        return subject;
    }

    public Patch setSubject(String subject) {
        this.subject = subject;
        return this;
    }

    public String getInReplyTo() {
        return inReplyTo;
    }

    public Patch setInReplyTo(String inReplyTo) {
        this.inReplyTo = inReplyTo;
        return this;
    }

    public String getReferenceList() {
        return referenceList;
    }

    public Patch setReferenceList(String referenceList) {
        this.referenceList = referenceList;
        return this;
    }

    public String getMbox() {
        return mbox;
    }

    public Patch setMbox(String mbox) {
        this.mbox = mbox;
        return this;
    }
}
