package lab.repository;

import lab.data.Patch;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;
import java.util.Map;

@Repository
public interface PatchRepository extends CrudRepository<Patch, Long> {

    @Query("select p.patchworkId from Patch p")
    List<Long> findAllPatchworkId();

    @Query("select new Patch(p.patchworkId, p.authorName, p.authorEmail) from Patch p order by p.patchworkId")
    List<Patch> findAllPatchAuthor();

    @Query("select new Patch(p.patchworkId, p.sendTime, p.authorName, p.authorEmail, p.subject) from Patch p where sendTime = ?1")
    List<Patch> findBySendTime(long sendTime);

    @Query(nativeQuery = true, value = "select * from patch where match(`subject`) AGAINST (?1 IN boolean mode) limit 5")
    List<Patch> findBySubjectLike(String subject);

    List<Patch> findByInReplyTo(String inReplyTo);

    List<Patch> findByPatchworkIdInOrderBySendTimeAsc(Collection<Long> patchworkIdIn);
}
